﻿import FlashServePkg.*;
		
class MiceTalk extends MovieClip {
var MOVESMAXLENGHT = 5;
var MOVESINTERVAL = 500;
var PREBUFFER = 0;
var MOVESGRANULARITY;
var mySocket:Object;
var ip:String;
var port:Number;
var nick:String;
var chan:String;
var moves:Array;
var lastSendTime:Number;
var lastMoveTime:Number;
var received:Boolean;
var players:Object;
var othersMoves:Object;
var msg:String;
var chat:MovieClip;
var tweenx:Object;
var tweeny:Object;
var c:Number =0;

public function MiceTalk(ip:String, port:Number, nick:String, trace1, trace2) {
		this.ip = ip;
		this.port = port;
		this.nick = nick;
		if(nick == null) this.nick = String(Math.floor(Math.random()*100000));
		
		this.chan = "prova";
		this.lastSendTime = Number.NEGATIVE_INFINITY;
		this.lastMoveTime = Number.NEGATIVE_INFINITY;
		this.received = true;
		this.moves = new Array();
		this.players = new Object();
		this.othersMoves = new Object();
		this.msg = "";
		
		this.MOVESGRANULARITY = MOVESINTERVAL / MOVESMAXLENGHT -1;
		
		this.mySocket = new FSSocket(trace1, trace2);
		this._register();
		
		//Chat:
		this.chat = this.attachMovie('chat', 'chat', this.getNextHighestDepth());
		Selection.setFocus(this.chat.chatText.txt);
		Selection.setSelection(this.chat.chatText.txt.text.length,this.chat.chatText.txt.text.length);
		
		chat.chatText.startDrag(true);
	}

	private function _register() {
		mySocket.addEventListener('onLogin', this);
		mySocket.addEventListener('onGame', this);
		mySocket.addEventListener('onSystem', this);
		mySocket.addEventListener('onNicklist', this);
		mySocket.addEventListener('onError', this);
		mySocket.addEventListener('onChanCreated', this);
		mySocket.addEventListener('onChatMsg', this);
		
		Key.addListener(this);
		Mouse.addListener(this);
	}

	public function send(str) {
		this.mySocket.sendGame(this.chan, str);
	}
	
	function onLogin(evt:Object) {
		var success:Boolean = evt.success;
		if (success) {
			trace("Connection succeeded!");
			this.send("/joingame " + this.chan);
			//_root.info = "connesso";
		} 
		else {
			_root.info = this.mySocket.e;
			if(this.mySocket.e == "nickinuse") {
				this.nick += String(Math.floor(Math.random() * 10));
				this.connect();
			}
		}
	}
	
	function onError(evt:Object) {
		var error = evt.error;
		var errMsg = evt.errMsg;
		//_root.info = ("Error: " + errMsg);
		_root.info = ("Error: Connection Failed");
	}
	
	function connect() {
		mySocket.connect(this.ip , this.port, this.nick);
	}
	
	function onGame(evt:Object) {
		var sender = evt.sender;
		var tokens = evt.tokens;
		var myData = evt.myData;
		if(sender == this.nick) {
			this.received = true;
		}
		else {
			this.moveReceived(evt);
		}
	}
	
	function sendMoves() {
		if(this.moves.length < 1) return;
		if((getTimer() - this.lastSendTime) < this.MOVESINTERVAL) return;
		this.lastSendTime = getTimer();
		
		//Always send the last move:
		/*var move:Object = new Object();
		move.x = this._xmouse;
		move.y = this._ymouse;
		move.time = getTimer();
		this.moves.push(move);
		*/
		var move = new Object();
		move.moves = this.moves;
		
		this.received = false;
		//#: game message, ##: 'ok' as echo
		this.send("##"+JSON.stringify(move));
		this.moves = new Array();
	}
	

	
	function moveReceived(evt:Object) {
		var sender = evt.sender;
		var tokens = evt.tokens;
		var myData = evt.myData;
		var move:Object = JSON.parse(tokens[0].substr(2)); //Strip ##
		
		if(this.othersMoves[sender] == undefined) {
			//Init:
			this.othersMoves[sender] = new Object();
			this.othersMoves[sender].lastMove = move.moves[0];
			this.othersMoves[sender].refRemoteTime = move.moves[0].time;
			this.othersMoves[sender].refLocalTime = getTimer() + this.PREBUFFER;
			this.othersMoves[sender].moves = move.moves.slice();
		}
		else {
			this.othersMoves[sender].moves = this.othersMoves[sender].moves.concat(move.moves);
		}
	}
	
	function onEnterFrame() {
		//Display moves:
		for(var sender in this.othersMoves) {
			//The buffer with moves:
			var move:Object = this.othersMoves[sender];
			var nextMove:Object = move.moves[0];
			if(nextMove != null) {
				var now:Number = getTimer();
				//Is passed enought time?
				if((now - move.refLocalTime) >= (nextMove.time - move.refRemoteTime)) {
					move.moves.shift();
					
					this.tweenx.stop();
					this.tweeny.stop();
					this.tweenx = new mx.transitions.Tween(this.players["p"+sender], "_x", mx.transitions.easing.None.easeNone, 
											this.players["p"+sender]._x, nextMove.x,  Math.round((nextMove.time - move.lastMove.time)/25), false);
					this.tweeny = new mx.transitions.Tween(this.players["p"+sender], "_y", mx.transitions.easing.None.easeNone, 
											this.players["p"+sender]._y, nextMove.y,  Math.round((nextMove.time - move.lastMove.time)/25), false);
					move.lastMove = nextMove; 
				}
			}
		}
		
		//Send moves to others:
		sendMoves();
	}
	
	function onNicklist(evt:Object) {
		if(evt.tipo == "/namelist") {
			for(var x=0; x < evt.nicklist.length; x++) {
				if(evt.nicklist[x].nome != this.nick) {
					this.players["p" + evt.nicklist[x].nome] = this.attachMovie('player', evt.nicklist[x].nome, this.getNextHighestDepth());
				}
			}
		}
		if(evt.tipo == "/join") {
			trace("Nuovo giocatore: " + evt.nome);
			this.players["p" + evt.nome] = this.attachMovie('player', evt.nome, this.getNextHighestDepth());
		}
		if(evt.tipo == "/part" || evt.tipo == "/quit") {
			this.players["p" + evt.nome].removeMovieClip();
			this.othersMoves[evt.nome] = undefined;
		}
	}
	
	function onKeyDown() {
		/*var code:Number = Key.getCode();
		switch (code) {
			case Key.BACKSPACE:
				this.msg = this.msg.substr(0, this.msg.length-1);
				break;
			case Key.DELETEKEY:
			case Key.CAPSLOCK:
			case Key.CONTROL:
			case Key.DOWN:
			case Key.END:
			case Key.ESCAPE:
			case Key.HOME:
			case Key.INSERT:
			case Key.LEFT:
			case Key.PGDN:
			case Key.PGUP:
			case Key.RIGHT:
			case Key.TAB:
			case Key.UP:
				break;
			case Key.SHIFT:
				break;
			default:
				this.msg += chr(Key.getAscii());
				
		}
		this.chat.chatText.text = this.msg;
		*/
		//if(eval(Selection.getFocus()).toString() != this.chat.chatText.txt.toString()) {
			//trace(eval(Selection.getFocus()) + " " + this.chat.chatText.txt);
			Selection.setFocus(this.chat.chatText.txt);
			Selection.setSelection(this.chat.chatText.txt.length,this.chat.chatText.txt.length);
			//Selection.setSelection(this.chat.chatText.txt.text.length-1,this.chat.chatText.text.length-1);
		//}
		
		if(Key.isDown(Key.ENTER)) {
			this.msg = this.chat.chatText.txt.text;
			var pos:Number;
			while((pos = this.msg.indexOf("\n")) != -1) {
				this.msg = this.msg.substring(0, pos) + this.msg.substr(pos+1);
			}
			if(this.msg != "") {
				this.mySocket.sendChat(this.chan, this.msg);
				this.msg = "";
				this.chat.chatText.txt.text = "";
			}
		}
	}
	
	function onChatMsg(evt:Object) {
		this.players["p" + evt.sender].msg.text = evt.message;
	}
	
	function onSystem(evt:Object) {
	}
	
	function onMouseMove() {
		if((getTimer() - this.lastMoveTime) < this.MOVESGRANULARITY) return;

		this.lastMoveTime = getTimer();
		var move:Object = new Object();
		move.x = this._xmouse;
		move.y = this._ymouse;
		move.time = getTimer();
		
		this.moves.push(move);
		
		//Fuzzy resample:
		//if(this.moves.length > this.MOVESMAXLENGHT) this.moves.splice(Math.floor(Math.random()*this.moves.length),1);
	}
}