﻿import mx.events.EventDispatcher;
import FlashServePkg.*;



/*
*/


class FlashServePkg.FSSocket extends XMLSocket {
//VARIABILI DI CLASSE:
static var DEBUG = true;
static var ERROR = true;

//VARIABILI PUBBLICHE:
public var gameChan:String = null;
//TODO: mettere globale questa var? o statica?
public var errMsg:String;
public var e:String;

//VARIABILI INTERNE:
private var fsPassword:String;
private var loggedIn:Boolean = false;
private var nick:String;

//GESTIONE CANALI:
private var channels:Object;
private var games:Object;

	
	function dispatchEvent() {};
 	function addEventListener() {};
 	function removeEventListener() {};

	function FSSocket(debug, error) {
		//Error è la funzione di errore, riceve una stringa col testo dell'errore
		super();
		if(arguments.length > 1) {
			this.onError = error; 
		}
		else {
			if(FSSocket.ERROR == false) {
				this.onError = null;
			}
		}
		
		if(arguments.length > 0) {
			this.debug = debug; 
		}
		else {
			if(FSSocket.DEBUG == false) {
				this.debug = null;
			}
		}
		
		this.channels = new Hash();
		this.games = new Hash();
		
		mx.events.EventDispatcher.initialize(this);

		debug("FSSocket initialized");
	}
	
	//############################### FUNZIONI PUBBLICHE #############################

	public function connect(ip:String, port:Number, nick:String, fsPassword:String) {
		this.nick = nick;
		this.fsPassword = fsPassword;
		
		debug("Connecting...");
				
		super.connect(ip, port);
	}
	
	public function close():Void {
		/* Function: close
			Chiude la connessione.
		*/
		super.close();
	}
	
	
	
	public function partChannel(chan:String):Boolean {
		/* Function: partChannel
			Fa uscire da un canale.
		*/
		if(this.channels[chan] == undefined) { return false; }
		
		this.channels.delObj(chan);
		this.onChanRemoved(chan);
		
		return true;
		
	}
	public function sendGame(chan:String, msg:String): Void {
		debug("Send: " + msg);
		this.send(msg);
		
	}
	
	public function sendChat(chan:String, msg:String): Void {
		if(msg.substr(0,1) == "/") {
			this.send(msg);
		}
		else {
			if (chan != this.gameChan) { 
				this.send("$" + chan + " " + msg);
			}
			else {
				this.send("#chat " + msg);
			}
		}
	}
	
	public function listGames(): Void {
		this.send("/listgames");
	}
	
	public function getChannels(): Array {
		return this.channels.toArray();
		
	}
	
	public function getNick(): String {
		return nick;
	}
	
	public function debug(msg:String): Void {
		/*
			Funzione di debug.
			Overridare:
		*/
		trace("D: " + msg);
	}
	
	function registerChat(chat) {
		this.addEventListener("onChatMsg", chat);
		this.addEventListener("onChanCreated", chat);
		this.addEventListener("onChanRemoved", chat);
		this.addEventListener("onNicklist", chat);
		this.addEventListener("onSystem", chat);
		this.addEventListener("onChanInfo", chat);
		this.addEventListener("onError", chat);
	}
	
	//############################# EVENTI ###############################
	
	function onLogin( success:Boolean ):Void {
		//debug("You should override this function. Ex: myFSSocket.onLogin = function() { ... }");
		/*
			Viene eseguita quando ci si connette o non ci si riesce.
		
		  placeholder: Overridare con quello che si vuole: 
		   myObj = new FSSocket;
		   myObj.onConnect = function () { ... }
		*/
		this.dispatchEvent({target:this, type:'onLogin', success:success});
	}
	
	function onChatMsg( sender:String, message:String, chan:String ) {
		//debug("You should override this function. Ex: myFSSocket.onChatMsg = function() { ... }");
		/*
			Viene eseguita quando arriva un messaggio di chat
			Questo è il modo semplice di ricevere messaggi, ma un solo oggetto
			può ricevere i messaggi.
			
			TODO: eventi come key.addlistener per FSSocket così da poter avere
			tante finestre di chat indipendenti.
			
			placeholder: Overridare.
		
		*/
		this.dispatchEvent({target:this, type:'onChatMsg', sender:sender, message:message, chan:chan});
		debug("sender: " + sender + " messaggio: " + message + " chan " + chan );
		
	}
	
	function onGame( sender:String, tokens:Array, myData:String ) {
		//debug("You should override this function. Ex: myFSSocket.onGame = function() { ... }");
		/*
			Viene eseguita quando arriva un comando di gioco
			
			placeholder: Overridare.
		
		*/
		this.dispatchEvent({target:this, type:'onGame', sender:sender, tokens:tokens, myData:myData});
	}
	
	function onSystem(myData:String): Void {
		/*
			Funzione per gestire i messaggi di sistema che non sono interni
			Overridare:
		*/
		this.dispatchEvent({target:this, type:'onSystem', myData:myData});
	}
	
	function onChanCreated( chan:String) {
		//debug("You should override this function. Ex: myFSSocket.onChanCreated = function() { ... }");
		/*
			Viene eseguita quando si entra in un nuovo canale
			
			placeholder: Overridare.
		
		*/

		this.dispatchEvent({target:this, type:'onChanCreated', chan:chan});
	}
	
	function onChanRemoved( chan:String) {
		//debug("You should override this function. Ex: myFSSocket.onChanRemoved = function() { ... }");
		/*
			Viene eseguita quando si entra in un nuovo canale
			
			placeholder: Overridare.
		
		*/
		this.dispatchEvent({target:this, type:'onChanRemoved', chan:chan});
	}
	
	function onChanInfo(chan:String, chanObj:Object) {
		/*
			Viene eseguita quando arrivano /chaninfo su un canale.
		
		*/
		this.dispatchEvent({target:this, type:'onChanInfo', chan:chan, chanObj:chanObj});
	}
	
	function onNicklist( chan:String, nicklist:Array, tipo:String, nome:String ) {
		//debug("You should override this function. Ex: myFSSocket.onNicklist = function() { ... }");
		/*
			//TODO: aggiungere pure se uno è joinato o partato e distinguere dal caso
				in cui sia un /namelist
			Viene eseguita quando cambia la nicklist ("/join" o "/part" o "/quit")
			Overridare.
			
		*/
		//debug("chan " + chan + " nicklist: " + nicklist);
		this.dispatchEvent({target:this, type:'onNicklist', chan:chan, nicklist:nicklist, tipo:tipo, nome:nome });
	}

	function onLobby( gameslist:Array ) {
		//debug("You should override this function. Ex: myFSSocket.onLobby = function() { ... }");
		/*
			Viene eseguita quando cambia la lobby list (/gamecreated removed o /listgames)
			Overridare.
			
		*/
		this.dispatchEvent({target:this, type:'onLobby', gameslist:gameslist});
	}
	
	function onClose (): Void {
		/*
			Viene eseguita quando la connessione viene chiusa.
		*/
		this.dispatchEvent({target:this, type:'onClose'});
	}
	
	function onError(msg:String): Void {
		/*
			Funzione di gestione degli errori.
			Overridare:
		*/
		trace("E: " + this.errMsg);
	}
		
	
	//#################### FINE FUNZIONI PUBBLICHE #########################
	
	function _error(msg:String): Void {
		/*
			Converte un comando di errore in una stringa leggibile.
			TODO: leggere gli errori da un xml
		*/
		this.e = msg;
		
		switch (msg) {
				case "connectionerror":
					this.errMsg = "Connessione fallita";
					break;
				case "badnick":
					this.errMsg = "Nick non ammesso o registrato";
					break;
				case "badlogin":
					this.errMsg = "Username o password sbagliati";
					break;
				case "nickinuse":
					this.errMsg = "Nickname in uso da un altro utente";
					break;
				default:
					this.errMsg = "Errore sconosciuto: " + msg;
		}
		this.dispatchEvent({target:this, type:'onError', e:msg, errMsg:this.errMsg});
		this.onError(msg);
	}
	
	function onConnect( success:Boolean ):Void {
		if(success) {
			this.logIn();
		}
		else {
			this._error("connectionerror");
		}
	}
	
	function logIn( Void ):Void {
		debug("Logging in...");
		
		//TMP: se non c'è un nick ne mette uno random:
		if(nick == null) { this.nick = String(Math.floor(Math.random()*1000)); }
		
		this.send("/nick " + nick);	
	}
	
	function onData( myData:String ):Void {
		debug("Data received: " + myData);
		if (this.loggedIn == false) {
			
			//##################### PRE LOGIN ####################
			this.offlineSystemCommands(myData);
		}
		else {
			//Se si è connessi:
			
			if (myData.substr(0,1) == "/") {
				
				//############### MESSAGGIO DI SISTEMA: ####################
				this.systemCommands(myData);
			}
			else {
			
				var msg = myData.split(">");
				var tokens = msg[1].split(" ");
				var sender = msg[0];
				//trace("tokens: " + tokens);
				
				switch (tokens[0].substr(0,1)) {
					case "#":
					
						//########## MESSAGGIO DI GIOCO: #(.*) #################
						
						if(tokens[0] == "#chat") {
							//Messaggio della chat ingame (si può stare in un solo gioco per connessione)
							this.onChatMsg( sender, msg[1].substring(6), this.gameChan);
						}
						else {
							this.onGame(sender, tokens, myData);
						}
						
						break;
					case "$":
						//#################### MESSAGGIO DI CHAT #######################
						//Messaggio di chat:$(.+) (.+) | $1 canale, $2 messaggio
						//                      v-- il messaggio senza il primo token  v- il primo token senza $
						this.onChatMsg(sender, msg[1].substring(tokens[0].length+1) , tokens[0].substring(1) );
						break;
				}
				
			}//fine di: if (myData.substr(0,1) = "/") {
			
		}//fine di: if (this.loggedIn == false) {
	}
	
	function systemCommands(myData:String): Void {
		/*
			Comandi di sistema ricevuti durante la connessione.
		*/
		
		var tokens = myData.split(" ");
			switch (tokens[0]) {
				case "/join":	
					//aggiungi il nuovo utente:
					this.channels[tokens[1]].addUser(tokens[2], tokens[0]);
					this.onNicklist(tokens[1], this.channels[tokens[1]].getUserList(), tokens[0], tokens[2]);
					
					break;
				case "/quit":
				case "/part":
					if(tokens[2] == this.nick) {
						//Se sei te rimuovi il canale.
						//TODO: questa cosa mi sembra poco pulita
						//SBAGLIATO! NON ricevo i miei part
						if(this.gameChan == tokens[2]) {
							this.gameChan = null;
						}
						
						this.partChannel(tokens[1]);
						this.onChanRemoved(tokens[1]);
					}
					else {
						//Cancella un utente che è uscito:						
						this.channels[tokens[1]].delUser(tokens[2], tokens[0]);
						this.onNicklist(tokens[1], this.channels[tokens[1]].getUserList(), tokens[0], tokens[2]);
					}
					break;
				case "/chaninfo":
					//Questo comando 'crea' il canale:
					if( this.channels[tokens[1]] == undefined ) {
						debug("Creato nuovo canale: " + tokens[1]);
						this.channels.addObj( tokens[1], new channel(tokens[1], this) );
						this.onChanCreated(tokens[1]);
					}
					//inserisci le informazioni (ad Es. l:3 t:0):
					var l:Number = tokens.length;
					var arg:Array;
					for(var x = 2; x < l; x++) {
						arg = tokens[x].split(":");
						switch (arg[0]) {
							case "l":
								//LIMITE:
								this.channels[tokens[1]].limit = arg[1];
								break;
							case "t":
								//TIPO: (0=chat, 1=scarabeo)
								this.channels[tokens[1]].type = arg[1];
								if(arg[1] != 0) {
									this.gameChan = tokens[1];
								}
								break;
							default:
								//PROPRIETA CUSTOM:
								var tmp = this.channels[tokens[1]];
								tmp["custom_" + arg[0]] = arg[1];
						}
						
					}
					//Emette l'evento:
					this.onChanInfo(tokens[1], this.channels[tokens[1]]);
					break;
				case "/namelist":
					//Aggiungi tutti gli utenti che si torvavano già nel canale:
					var x:Number = 2;
					var l:Number = tokens.length;
					while(x < l) {
						this.channels[tokens[1]].addUser(tokens[x]);
						x++;
					}
					
					this.onNicklist(tokens[1], this.channels[tokens[1]].getUserList(), tokens[0], null);
					break;
				case "/gamecreated":
					this.games.addObj( tokens[1], new gameRoom(tokens[1], tokens[2], tokens[3]) );
					this.onLobby(this.games.toArray());
					break;
				case "/gameremoved":
					this.games.delObj(tokens[1]);
					this.onLobby(this.games.toArray());
					break;
				case "/listgames":
					// /listgame chan limit users
					var x:Number = 1;
					var l:Number = tokens.length;
					
					delete this.games;
					this.games = new Hash();
					
					while(x < l-2) {
						//debug("games:" + l +" " + tokens[x] + " " + tokens[x+1] + " " + tokens[x+2]);
						this.games.addObj( tokens[x], new gameRoom(tokens[x], tokens[x+1], tokens[x+2], tokens[x+3]) );
						x = x + 4;
					}
					
					this.onLobby(this.games.toArray());
				
					break;
				default:
					//Messaggio definito dall'utente:
					this.onSystem(myData);
			}
	}
	
	function offlineSystemCommands(myData:String): Void {
		/*
			Comandi di sistema ricevuti prima di connettersi. 
		*/
		switch (myData) {
			case "/badnick":
				this._error("badnick");
				this.onLogin(false);
				break;
			case "/badlogin":
				this._error("badlogin");
				this.onLogin(false);
				break;
			case "/nickinuse":
				this._error("nickinuse");
				this.onLogin(false);
				break;
			case "/connected":
				this.onLogin(true);
				this.loggedIn = true;
				break;
			default:
				//Messaggio definito dall'utente:
				this.onSystem(myData);
		}
	}	

	
}