﻿

interface FSSocket_interface {
	
	function onLogin( success:Boolean ):Void {
		//debug("You should override this function. Ex: myFSSocket.onLogin = function() { ... }");
		/*
			Viene eseguita quando ci si connette o non ci si riesce.
		
		  placeholder: Overridare con quello che si vuole: 
		   myObj = new FSSocket;
		   myObj.onConnect = function () { ... }
		*/
	}
	
	function onChatMsg( sender:String, message:String, chan:String ) {
		//debug("You should override this function. Ex: myFSSocket.onChatMsg = function() { ... }");
		/*
			Viene eseguita quando arriva un messaggio di chat
			Questo è il modo semplice di ricevere messaggi, ma un solo oggetto
			può ricevere i messaggi.
			
			TODO: eventi come key.addlistener per FSSocket così da poter avere
			tante finestre di chat indipendenti.
			
			placeholder: Overridare.
		
		*/
		//debug("sender: " + sender + " messaggio: " + message + " chan " + chan );
		
	}
	
	function onCommand( sender:String, tokens:Array, myData:String ) {
		//debug("You should override this function. Ex: myFSSocket.onCommand = function() { ... }");
		/*
			Viene eseguita quando arriva un comando di gioco
			
			placeholder: Overridare.
		
		*/
		
	}
	
	function onChanCreated( chan:String) {
		//debug("You should override this function. Ex: myFSSocket.onChanCreated = function() { ... }");
		/*
			Viene eseguita quando si entra in un nuovo canale
			
			placeholder: Overridare.
		
		*/


	}
	
	function onChanRemoved( chan:String) {
		//debug("You should override this function. Ex: myFSSocket.onChanRemoved = function() { ... }");
		/*
			Viene eseguita quando si entra in un nuovo canale
			
			placeholder: Overridare.
		
		*/
		
	}
	
	function onNicklist( chan:String, nicklist:Array ) {
		//debug("You should override this function. Ex: myFSSocket.onNicklist = function() { ... }");
		/*
			Viene eseguita quando cambia la nicklist (join o part/quit)
			Overridare.
			
		*/
		//debug("chan " + chan + " nicklist: " + nicklist);
	}

	function onLobby( gameslist:Array ) {
		//debug("You should override this function. Ex: myFSSocket.onLobby = function() { ... }");
		/*
			Viene eseguita quando cambia la lobby list (/gamecreated removed o /listgames)
			Overridare.
			
		*/
		//debug("gameslist: " + gameslist);
	}
	
	function onSystem(myData:String): Void {
		/*
			Funzione per gestire i messaggi di sistema inseriti dall'utente
			Overridare:
		*/
	}
}