﻿
interface IFSGame {
	
	function onLogin( success:Boolean ):Void {
		//debug("You should override this function. Ex: myFSSocket.onLogin = function() { ... }");
		/*
			Viene eseguita quando ci si connette o non ci si riesce.
		
		  placeholder: Overridare con quello che si vuole: 
		   myObj = new FSSocket;
		   myObj.onConnect = function () { ... }
		*/
		this.dispatchEvent({target:this, type:'onLogin', success:success});
	}
	
	function onChatMsg( sender:String, message:String, chan:String ) {
		//debug("You should override this function. Ex: myFSSocket.onChatMsg = function() { ... }");
		/*
			Viene eseguita quando arriva un messaggio di chat
			Questo è il modo semplice di ricevere messaggi, ma un solo oggetto
			può ricevere i messaggi.
					
			placeholder: Overridare.
		
		*/
		this.dispatchEvent({target:this, type:'onChatMsg', sender:sender, message:message, chan:chan});
		debug("sender: " + sender + " messaggio: " + message + " chan " + chan );
		
	}
	
	function onGame( sender:String, tokens:Array, myData:String ) {
		//debug("You should override this function. Ex: myFSSocket.onGame = function() { ... }");
		/*
			Viene eseguita quando arriva un comando di gioco
			
			placeholder: Overridare.
		
		*/
		this.dispatchEvent({target:this, type:'onGame', sender:sender, tokens:tokens, myData:myData});
	}
	
	function onSystem(myData:String): Void {
		/*
			Funzione per gestire i messaggi di sistema che non sono interni
			Overridare:
		*/
		this.dispatchEvent({target:this, type:'onSystem', myData:myData});
	}
	
	function onChanInfo(chan:String, chanObj:Object) {
		/*
			Viene eseguita quando arrivano /chaninfo su un canale.
		
		*/
		this.dispatchEvent({target:this, type:'onChanInfo', chan:chan, chanObj:chanObj});
	}
	
	function onNicklist( chan:String, nicklist:Array, tipo:String, nome:String ) {
		//debug("You should override this function. Ex: myFSSocket.onNicklist = function() { ... }");
		/*
			//TODO: aggiungere pure se uno è joinato o partato e distinguere dal caso
				in cui sia un /namelist
			Viene eseguita quando cambia la nicklist ("/join" o "/part" o "/quit")
			Overridare.
			
		*/
		//debug("chan " + chan + " nicklist: " + nicklist);
		this.dispatchEvent({target:this, type:'onNicklist', chan:chan, nicklist:nicklist, tipo:tipo, nome:nome });
	}

	function onClose (): Void {
		/*
			Viene eseguita quando la connessione viene chiusa.
		*/
		this.dispatchEvent({target:this, type:'onClose'});
	}
	
	function onError(msg:String): Void {
		/*
			Funzione di gestione degli errori.
			Overridare:
		*/
		trace("E: " + this.errMsg);
	}
}