﻿import FlashServePkg.*;
import FlashServePkg.UI.*;
/*

	TODO: sistemare la chat di gioco (bisogna modificare il server)
*/

class FlashServePkg.UI.chat extends MovieClip implements FlashServePkg.IFSChat {
	
public var chatBox:MovieClip;
public var chatInput:MovieClip;
public var scrollbar:MovieClip;
public var scrollUp:MovieClip;
public var scrollDown:MovieClip;
public var constraint:MovieClip;
public var lista:MovieClip;

//VARIABILI PRIVATE:
private var FSSocket:Object;
private var currentChan:String;
private var channelBuffer:Object;
private var taskbar:Object;
public var defButton:Object;

	function chat() {
		//TODO: check di queste cose:
		if(this.chatBox == undefined) { 
			trace("Non è presente un oggetto col nome  di istanza 'chatBox' nella chat."); 
		}
		//Assegno gli eventi ai rispettivi movieclip:
		this.createChatInput();
		this.createScrollbar();
		this.createScrollUp();
		this.createScrollDown();
		
		//Ogni canale viene memorizzato in un buffer
		this.channelBuffer = new Hash();
		
		this.defButton = new Object();
		this.defButton.chat = this;
		this.defButton.onPress = function () {
			this.chat.setChan(this.chan);
		}
		
	}
	
	//###################### FUNZIONI DA USARE: ######################
	
	public function setChan(chan:String): Void {
		/*
			Funzione per cambiare il canale correntemente visualizzato.
		*/
		//imposta il canale corrente:
		this.currentChan = chan;
		
		//Aggiorna la visualizzazione:
		this.setHtml(this.channelBuffer[chan].buffer);
		this.fillNicklist(this.channelBuffer[chan].nicklist);
	
	}
	
	public function setEnviroment(Socket:Object, Taskbar:Object): Void {
		/*
			Funzione che imposta il socket FlashServe da usare.
		*/
		this.taskbar = Taskbar;
		this.FSSocket = Socket;
		
		//Registra gli eventi:
		this.FSSocket.registerChat(this);
		
		var a:Array = Socket.getChannels();
		var l:Number = a.length;
		var o:Object;
		for(var x = 0; x < l; x++) {
			o = new Object();
			o.chan = a[x].nome;
			this.onChanCreated( o );
		}
		
	}
	
	function addBuffer(chan, msg) {
		/*
			Funzione che aggiunge un msg nel buffer di un canale.
		*/
		
		if( (this.currentChan == chan) || ( (chan == undefined) && (this.currentChan == null))) {
			this.addHtml(msg);
		}
		
		this.channelBuffer[chan].buffer += msg;
	}
	
	
	/*
		Funzioni che aggiungono testo al chatBox:
	*/
	function addText(s:String): Void {
		this.chatBox.text += s;
		
	}
	
	function addLine(s:String): Void {
		this.chatBox.text += s + "\r";
		
	}
	
	function addHtml(s:String): Void {
		this.chatBox.htmlText += s;
		
	}
	
	function setText(s:String): Void {
		this.chatBox.Text = s;
	}
	
	function setHtml(s:String): Void {
		this.chatBox.htmlText = s;
	}
	
	public function listGames(): Void {
		this.FSSocket.listGames();
	}
	
	public function sendChat(chan:String, msg:String):Void {
		this.FSSocket.sendChat(chan, msg);
	}
	
	public function sendCommand(command:String): Void {
		this.FSSocket.sendChat("", command);
	}
	//################ FUNZIONI INTERNE: ####################
	
	//Eventi:
	function onChatMsg( evt:Object ) {
		// Funzione che aggiunge un messaggio di un utente alla chat
		
		//Se il canale è visualizzato in questo momento mostra il messaggio
		if( (this.currentChan == evt.chan) || ( (evt.chan == undefined) && (this.currentChan == null))) {
			this.addHtml(" " + evt.sender + "> " + evt.message + "\r");
			
			//Mostra l'ultima riga inserita:
			if(this.scrollbar.premuto != true) {
				this.chatBox.scroll = this.chatBox.maxscroll;
			}
		}
		
		//Memorizza il messaggio nel buffer:
		this.channelBuffer[evt.chan].buffer += " " + evt.sender + "> " + evt.message + "\r";
	}
	
	function onChanCreated( evt:Object) {
		//Evento eseguito quando si entra in un nuovo (per FSSocket) canale:
		var chanName:String = evt.chan;
		//se si entra in un nuovo canale:
		if (this.channelBuffer[chanName] == undefined) {
			var obj = new Object();
			obj.buffer = "Connected to " + chanName + "\r";
			this.channelBuffer.addObj(chanName, obj );
			
			if(this.currentChan == undefined) { this.currentChan = chanName; }
			
			//crea il pulsante:
			var myButton2:Object = new Object();
			myButton2.Taskbar = this.taskbar;
			myButton2.onPress = function () {
				_root.taskbar.showApp(this.taskName);
			}
			this.defButton.chan = chanName;
			//trace("ch: " + evt.chan);
			this.taskbar.addTaskButton(chanName, "chan", this.defButton, true);
			
		}
	}
	
	function onChanRemoved( evt:Object) {
		//Evento: quando si esce da un canale
				
		//TODO: Dovrebbe rimanere aperto finchè l'utente non lo chiude
		//this.channelBuffer.delObj(evt.chan);
		this.addBuffer(evt.chan , " *** Sei uscito dal canale");
	}
	
	function onNicklist( evt:Object ) {
		//Evento: quando cambia la nicklist (join/part/quit)
		//TODO: internazionalizzare i messaggi.
		this.channelBuffer[evt.chan].nicklist =	evt.nicklist;
		// Riempi la nicklist:
		if(this.currentChan == evt.chan) { this.fillNicklist(evt.nicklist); }
		
		//Mostra il messaggio:
		switch (evt.tipo) {
			case "/join":
			this.addBuffer(evt.chan , " *** " + evt.nome + " has joined " + evt.chan + "\r");
			break;
		
			case"/part":
			this.addBuffer(evt.chan ," *** " + evt.nome + " has left " + evt.chan + "\r");
			break;
		
			case "/quit":
			this.addBuffer(evt.chan ," *** " + evt.nome + " has quit" + "\r");
			break;
		
			case "/namelist":
			break;		
		}
	}
	
	function onSystem(evt:Object): Void {
		this.addBuffer(this.currentChan, "SERVER: " + evt.myData + "\r");
	}
	
	function onChanInfo(evt:Object) :Void {
		trace("addbuffer: " + evt.chan);
		this.addBuffer(evt.chan, "Limit: " + evt.chanObj.limit + " Type: " + evt.chanObj.type + "\r");
	}
	
	function onError(evt:Object): Void {
		this.addBuffer(this.currentChan, "Error: " + evt.errMsg + "\r");
		
	}
	
	//Funzioni:
	
	function fillNicklist ( a:Array ): Void {
		//Riempie la nicklist:
		this.lista.clearAll();
		
		var l:Number = a.length;
		
		for(var x = 0; x < l; x++) {
			//l'oggetto item dovrebbe rispecchiare l'oggetto user, ma per ora:
			var obj:Object = new item();
			obj.nome = a[x].nome;
			this.lista.addObj(obj);
		}
	}
	
	function onInput(txt:String): Void {
		//Quando l'utente invia un messaggio:
		this.FSSocket.sendChat(this.currentChan, txt);
		
	}
	
	//	FUNZIONI DI INIZIALIZZAZIONE DEL MOVIECLIP:
	
	function createChatInput():Void {
		this.chatInput.onSetFocus = function () {
			this.focus = true;
		}
		
		this.chatInput.onKillFocus = function () {
			this.focus = false;
		}


		Key.addListener(this.chatInput);
	
		this.chatInput.onKeyUp = function () {
		
			if ((Key.getCode() == Key.ENTER) && (this.focus) && (this.text != "")) {
				//#################### manda il testo #############################
				_parent.onInput(this.text);
				
				//Svuota la textbox:
				this.text = "";
			}
		}
	}
	
	function createScrollbar():Void {
		this.scrollbar._y = this.constraint._y;
		
		this.scrollbar.onPress = function () {
			this.pressed = true;
			this.startDrag(false, this._x, _parent.constraint._y, this._x, _parent.constraint._y + _parent.constraint._height - this._height);
		}
		
		this.scrollbar.onRelease = function () {
			this.pressed = false;
			this.stopDrag();
		}
		
		this.scrollbar.onReleaseOutside = function () {
			this.pressed = false;
			this.stopDrag();
		}
		
		this.scrollbar.onMouseMove = function () {
			if(this.pressed) {
				_parent.chatBox.scroll = Math.round( _parent.chatBox.maxscroll / ((_parent.constraint._height - this._height) / this._y));
				
			}
		}
		
		
	}
	
	function createScrollUp():Void {
		this.scrollUp.onPress = function () {
			_parent.chatBox.scroll -= 1;
		}
		
	}
	
	function createScrollDown():Void {
		this.scrollDown.onPress = function () {
			_parent.chatBox.scroll += 1;

		}
	}
	
}