﻿import FlashServePkg.*;
import FlashServePkg.UI.*;
/*
	Classe: chatSingle extends chat
		E' una chat con un unico canale.
		questo si può impostare manualmente con setChan (non sarà + possibile cambiarlo)
		altrimenti il primo canale in cui si entra diverrà l'unico canale possibile
	
*/

class FlashServePkg.UI.chatSingle extends FlashServePkg.UI.chat {
	
//l'unico canale in cui opera questa chat:
private var chanLock:String;
		
	function chatSingle() {
		super();
		
	}
	//Funzioni:
	
	public function setChan(chan:String): Void {
		//Si può cambiare canale solo se non è stato ancora definito:
		//(può essere definito a mano a aspettare che entri nel primo chan)
		if(this.chanLock != undefined) {
			return;
		}
		this.chanLock = chan;
		super.setChan(chan);
	}
	
	//############## EVENTI #################
	function onChatMsg( evt:Object ) {
		
		//se il canale non è l'unico valido per questa chat a singolo canale ignora l'azione:
		if( (this.currentChan != undefined) && (evt.chan != this.chanLock) ) {
			return;
		}
		
		super.onChatMsg(evt);
	}
	
	function onChanCreated( evt:Object) {
		//Se non impostato manualmente, il primo canale in cui si entra diventa l'unico canale.
		
		//se il canale non è l'unico valido per questa chat a singolo canale ignora l'azione:
		if( (this.currentChan != undefined) && (evt.chan != this.chanLock) ) {
			return;
		}
		
		super.onChanCreated(evt);
	}
	
	function onChanRemoved( evt:Object) {
		//se il canale non è l'unico valido per questa chat a singolo canale ignora l'azione:
		if( (this.currentChan != undefined) && (evt.chan != this.chanLock) ) {
			return;
		}
		
		super.onChanRemoved(evt);
		
	}
	
	function onNicklist( evt:Object ) {
		//se il canale non è l'unico valido per questa chat a singolo canale ignora l'azione:
		if( (this.currentChan != undefined) && (evt.chan != this.chanLock) ) {
			return;
		}
		
		super.onNicklist(evt);
	}
	
	function onSystem(evt:Object): Void {
		//se il canale non è l'unico valido per questa chat a singolo canale ignora l'azione:
		if( (this.currentChan != undefined) && (evt.chan != this.chanLock) ) {
			return;
		}
		
		super.onSystem(evt);
	}
	
	function onChanInfo(evt:Object): Void {
		//se il canale non è l'unico valido per questa chat a singolo canale ignora l'azione:
		if( (this.currentChan != undefined) && (evt.chan != this.chanLock) ) {
			return;
		}
		
		super.onChanInfo(evt);
	}
	
	function onError(evt:Object): Void {
		//se il canale non è l'unico valido per questa chat a singolo canale ignora l'azione:
		if( (this.currentChan != undefined) && (evt.chan != this.chanLock) ) {
			return;
		}
		
		super.onError(evt);
	}
}