﻿import FlashServePkg.*;
import FlashServePkg.UI.*;
/*
	Classe di definizione di una list.
	
	addObj(object, [string]) si aggiungono item
		obj è un oggetto con le proprietà da assegnare al nuovo item
		item è opzionale, specifica un oggetto diverso da inserire 
		(si può cambiare una volta per tutte con setItem(string);
											
	setItem(string) cambia il nome di default degli item inseriti				
														 
    questa classe va assegnata (Link) ad un MovieClip già esistente
	
	Il MovieClip deve avere i seguenti movieclip al suo interno (con i seguenti nomi):
			scroll = tasto per scrollare
			up = tasto per mandare in alto di 1
			down = tasto pe mandare in basso di 1
			constraint = oggetto che limita i movimenti di scroll: 
				deve essere posizionato in alto ed essere lungo quanto tutta la scrollbar
			mask = la maschera che determina in punto in cui vanno gli items
			
	Mentre nella library deve esserci:
			item = oggetto che determina ogni item nella lista.
			(il nome può essere cambiato con setItem(string))

*/

class FlashServePkg.UI.list extends MovieClip {
	
private var ndepth:Number = -1;
private var item:String = "item";
private var increment:Number = 5;

public var spaziamentoY:Number = 0;

public var placeholder:MovieClip;
public var scrollbar:MovieClip;
public var constraint:MovieClip;
public var scrollUp:MovieClip;
public var scrollDown:MovieClip;

	function list () {
		
		// Inizializza:
		this.listIfy(this);
		this.createScrollUp();
		this.createScrollDown();
		
	}
	
	//########## FUNZIONI DELLA LIST #########################
	
	public function addObj (obj:Object, item:String): Void {
		/*
			Aggiunge l'oggetto nella lista.
			item è facoltativo.
			se specificato usa un item diverso da quello di default("item")
			
		*/
		
		this.ndepth++;
		if(item == undefined) { item = this.item; }

		this.placeholder.attachMovie(item, "items" + this.ndepth , this.ndepth, obj);
		this.placeholder["items" + this.ndepth]._x = 0;
		this.placeholder["items" + this.ndepth]._y = (this.placeholder["items" + this.ndepth]._height + this.spaziamentoY) * this.ndepth;
	}
	
	public function clearAll (): Void {
		/*
		
			Pulisce la list.
		
		*/
		for(var x=0; x <= this.ndepth; x++) {
			this.placeholder["items" + x].removeMovieClip();
		}
		this.ndepth = -1;
	}
	
	function setItem(newitem:String) {
		/*
		
			Cambia l'item di default.
			
		*/
		this.item = newitem;
	}
	
	
	
	
	//################## INIZIALIZZAZIONE: ####################
	
	function listIfy (parent) {
	/*
		Funzione che fa diventare un oggetto una list.
		
	*/
	
		//INIZIALIZZAZIONE:
		parent.ndepth = -1;
		//parent.constraint._visible = false;
		
		//Oggetto di comodo per posizionare gli items:
		//this.placeholder = parent.createEmptyMovieClip("placeholder", 1);
		//parent.placeholder._y = parent.mask._y;
		//parent.placeholder._x = parent.mask._x;
		parent.placeholder.starty = parent.placeholder._y;
		//parent.placeholder.starty = parent.mask._y;
		
		parent.placeholder.setMask(parent.mask);
		
		//Posiziona la scrollbar in alto
		parent.scrollbar._y = parent.constraint._y;
		
		parent.scrollbar.tooltipText = "ciao";
		
		//########## FUNZIONI DELLA SCROLLBAR ####################
	
		parent.scrollbar.onPress = function () {
			this.pressed = true;
			this.startDrag(false, this._x, this._parent.constraint._y, this._x, this._parent.constraint._y + this._parent.constraint._height - this._height);
		}
		
		parent.scrollbar.onRelease = function () {
			this.pressed = false;
			this.stopDrag();
		}
		
		parent.scrollbar.onReleaseOutside = function () {
			this.pressed = false;
			this.stopDrag();
		}
		
		parent.scrollbar.onMouseMove = function () {
			if(this.pressed) {
				if(this._parent.placeholder._height > this._parent.mask._height) {
				this._parent.placeholder._y = this._parent.placeholder.starty - ( (this._parent.placeholder._height - this._parent.mask._height) * ( (this._y - this._parent.constraint._y) / (this._parent.constraint._height - this._height) ));
		
				}
			}
		}
		
	}
	
	function createScrollUp():Void {
		this.scrollUp.increment = this.increment;
		
		this.scrollUp.onPress = function () {
			var max = this._parent.placeholder.starty;
			
			this._parent.placeholder._y += this.increment;
			if(this._parent.placeholder._y > max) { 
				this._parent.placeholder._y = max;
			}
		}
		
	}
	
	function createScrollDown():Void {
		this.scrollDown.increment = this.increment;
		
		this.scrollDown.onPress = function () {
			var min = this._parent.placeholder.starty - this._parent.placeholder._height + 
													this._parent.mask._height;
													
			this._parent.placeholder._y -= this.increment;
			if(this._parent.placeholder._y < min) { 
				this._parent.placeholder._y = min;
			}
		}
	}

	
}